Disable grub feature by default
[grml-terminalserver.git] / grml-terminalserver-config
index aa45405..cd50d7b 100755 (executable)
@@ -1,10 +1,9 @@
-#!/bin/sh
+#!/bin/bash
 # Filename:      terminalserver-config
 # Purpose:       configuration program for grml-terminalserver
 # Authors:       grml-team (grml.org), (c) Michael Gebetsroither <gebi@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
-# Latest change: Don Nov 16 14:39:51 CET 2006 [mika]
 ################################################################################
 
 
@@ -122,13 +121,55 @@ function actionAutoconf
 
 
 # INITRD {{{
-
 function actionMkInitrd
 {
-  echo -n "Creating initrd $PATH_/minirt26.gz: "
-  isExistent "$PATH_/minirt26.gz" && echo && echo "$PATH_/minirt26.gz exists already, skipping initrd creation" && return 0
-  mkInitrd
-  echo done
+  echo
+  echo "Creating initrd $PATH_/minirt26.gz:"
+  if isExistent "$PATH_/minirt26.gz" ; then
+     echo
+     echo "$PATH_/minirt26.gz exists already, skipping initrd creation"
+     return 0
+  fi
+
+  if [ -e '/live/cow' ]; then
+    mkInitrdNew
+  else
+    mkInitrd
+  fi
+  echo '... done'
+}
+
+function mkInitrdNew
+{
+  # we do not want to include persistent configuration files
+  # from udev in the initrd
+  udev_tmp_=$(mktemp -d terminalserver__udev.XXXXXX)
+  persistent=false
+  if ls /etc/udev/rules.d/*persistent* >/dev/null 2>&1 ; then
+    persistent_files=true
+    for f in /etc/udev/rules.d/*persistent* ; do
+      mv "$f" "${udev_tmp_}/"
+    done
+  fi
+
+  set -e
+  local cfg_="/etc/initramfs-tools/initramfs.conf"
+  local tmp_="`mktemp -t terminalserver__initramfsbk.XXXXXX`"
+  cp $cfg_ $tmp_
+  sed -i 's/^MODULES=.*/MODULES=netboot/' $cfg_
+  update-initramfs -u -t 1>/dev/null
+  mv $tmp_ $cfg_
+
+  local initrd_="/boot/initrd.img-$KERNEL_VERSION_"
+  mv $initrd_ $PATH_/minirt26.gz
+  mv ${initrd_}.bak $initrd_
+  set +e
+
+  # restore udev configuration files
+  if $persistent_files ; then
+    mv ${udev_tmp_}/* /etc/udev/rules.d/
+    rmdir "${udev_tmp_}"
+  fi
 }
 
 function mkInitrd
@@ -274,7 +315,7 @@ for addresses from 192.168.0.101 to (and including) 192.168.0.200.
   local grub_message_="Do you have any NON-PXE network cards you would like to boot from?"
 
   # on witch interfaces should we listen
-  local netdevices_="$(cat /proc/net/dev | awk -F: '/eth.:|tr.:/{print $1}')"
+  local netdevices_="$(grep -ve 'lo:' -ve 'Inter-|' -ve 'face |bytes' /proc/net/dev | awk -F: '{print $1}')"
   local device_list_=""
   for INTERFACE_ in $netdevices_; do device_list_="$device_list_ ${INTERFACE_} Networkcard_${INTERFACE_##eth}"; done
     echo -n "" >"$TMP_"
@@ -338,11 +379,12 @@ the internet?"
   fi
 
 
-  # grub
-  echo -n "" >"$TMP_"
-  local grub_write_="YES"
-  $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$grub_title_" --yesno "$grub_message_" 5 75 && \
-    grubConfig || grub_write_="NO"
+  # grub -> do not use it anymore
+  # echo -n "" >"$TMP_"
+  # local grub_write_="YES"
+  # $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$grub_title_" --yesno "$grub_message_" 5 75 && \
+  #  grubConfig || grub_write_="NO"
+  grub_write_="NO"
 
 
   # get options
@@ -397,9 +439,8 @@ Quite usefull examples:
 
 ssh=<pw>              - Start ssh server and set password of user grml to pw
 services=<1,2,3>      - Execute /etc/init.d/{1,2,3} start
-console=ttyS0,9600n8  - Initialise seriell console
-secure                - Boot only restricted clients (without root permissions)
-startx                - Boot into X (should be used with secure)
+console=ttyS0,9600n8  - Initialise serial console
+startx                - Boot into X
 
 
 "
@@ -424,7 +465,7 @@ function optGrml2Hd
   local options_='BOOT_IMAGE=grml2hd'
 
   # get partition to install grml2hd on
-  OPTIONS_PARTITION_MSG_='Please give me the target partition where to install grml'
+  OPTIONS_PARTITION_MSG_='Please specify the target partition where to install grml'
   PARTITION_TITLE_='Partition selection'
   echo -n "" >"$TMP_"
   $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$PARTITION_TITLE_" --inputbox \
@@ -433,7 +474,7 @@ function optGrml2Hd
   options_="$options_ $tmp_"
 
   # get filesystem type
-  OPTION_FS_TYPE_='Please give me the filesystem type'
+  OPTION_FS_TYPE_='Please specify the filesystem type'
   FS_TITLE_='Filesystem selection'
   echo -n "" >"$TMP_"
   $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$FS_TITLE_" --inputbox \
@@ -442,7 +483,7 @@ function optGrml2Hd
   options_="$options_ $tmp_"
 
   # get where to save mbr
-  OPTION_MBR_='Please give me the location where to save the mbr'
+  OPTION_MBR_='Please specify the location where to save the mbr'
   MBR_TITLE_='Select location of mbr'
   echo -n "" >"$TMP_"
   $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$MBR_TITLE_" --inputbox \
@@ -482,10 +523,10 @@ function grubConfigWork
 
   local grub_title_="Grub configuration"
   local grub_nic_message_="
-Give me the types of network cards you would want to boot from.
-If you networkcard is already listed press <OK>!
+Please select the types of network cards you want to boot from.
+If your networkcard is already listed just press <OK>!
 
-WARNING: DON't add all NIC's, grub could possibly stop working!!"
+WARNING: Do NOT add all NICs, grub could possibly stop working!"
   local nics_=""
 
   if [[ $2 == "" ]]; then
@@ -498,9 +539,12 @@ WARNING: DON't add all NIC's, grub could possibly stop working!!"
     $DIALOG_ --clear --separate-output --backtitle "$BACK_TITLE_" --title "$grub_title_" --checklist \
       "$grub_nic_message_" 10 70 0 $nics_ 2>$TMP_
     local ret_=$?
-    if [[ $ret_ -ne 0 || `wc -l <$TMP_` -eq 0 ]]; then
+    if [[ $ret_ -ne 0 ]]; then
+       die "exiting as requested"
+    fi
+    if [[ `wc -l <$TMP_` -eq 0 ]]; then
       echo $ret_
-      warn "you should give me your specified NICs but didn't => DEFAULT will be used"
+      warn "you should specify the NICs but didn't => DEFAULT will be used"
       awk '/ on$/{print $1}' $GRUB_NIC_CONF_ >$TMP_
     fi
   else
@@ -513,6 +557,7 @@ WARNING: DON't add all NIC's, grub could possibly stop working!!"
   echo "\"$cmd_line_\""
 
   execute "tar xzf $GRUB_SOURCE_ -C $tmp_" warn || return 1
+  local_dir="$(pwd)"
   execute "cd $tmp_/grub*" warn || return 1
 cat >preset-menu <<EOT
 # Set up the serial terminal, first of all.
@@ -528,17 +573,26 @@ timeout 0
 title Load config from Tftp server
   configfile (nd)/menu.lst
 EOT
-  #execute "./configure --enable-diskless --enable-preset-menu=./preset-menu $cmd_line_" warn || read
-  execute "CC=gcc-3.3 ./configure --enable-preset-menu=./preset-menu $cmd_line_" warn || read
-  execute "make -j2 CC=gcc-3.3" warn || read #return 1
+
+  CC='gcc'
+  test -r /lib64 && export CC="$CC -m32"
+
+  CC="$CC" execute "./configure --enable-preset-menu=./preset-menu $cmd_line_" warn || read
+  CC="$CC" execute "make -j2" warn || read #return 1
 
   local st1_="stage1/stage1"
   local st2_="stage2/stage2"
   isExistent $st1_ warn || return 1
   isExistent $st2_ warn || return 1
 
-  execute "mv -fb $PATH_/grub.img $PATH_/grub.img.old"
+  if [ -r "$PATH_/grub.img" ] ; then
+     execute "mv -fb $PATH_/grub.img $PATH_/grub.img.old"
+  fi
+
   execute "cat $st1_ $st2_ > $PATH_/grub.img" warn || return 1
+
+  cd "$local_dir"
+
   return 0
 }
 
@@ -546,7 +600,7 @@ function grubWrite
 {
   local grub_title_="Grub configuration"
   $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$grub_title_" --yesno \
-    "Do you want to write your grub image to /dev/fd0" 5 75 || return 1
+    "Do you want to write the grub image to /dev/fd0" 5 75 || return 1
 
   execute "dd if=$PATH_/grub.img of=/dev/fd0" warn || return 0
   return 1
@@ -556,7 +610,7 @@ function grubMultiWrite
 {
   local target_=${1:-'/dev/fd0'}
 
-  isExistent "$PATH_/grub.img" die "you must give me an image or run \"$PROG_NAME__ grubconf\""
+  isExistent "$PATH_/grub.img" die "you have to specify an image or run \"$PROG_NAME__ grubconf\""
   isExistent "$target_" die "$target_ is not a valied"
   while true; do
     echo -n "Please insert disk into $target_ and press <ENTER> (STRG-C for end)"